% Demonstrate mid point snaps. To be run from snaps.rsc - not stand alone
.new_text
A mid point snap can be used on any segment of an element, a ray or
a tape measure. When you select a mid point snap the cursor changes
to a small box and the word Middle.
.pause
.new_text
The cursor should be positioned so that the box lies over some part
of the ray, element segment or tape measure.


For example to specifiy the mid point of the left side of the prism ray
in this diagram the cursor could be positioned anywhere over that side.


Click on continue and this will be demonstrated to you.
.pause
.annotation Clicking here with a mid snap
.fc -112 33
.fcr 20 -30
.new_text
Clicking with a mid snap with a ray or line or arc segment passing
through the small cursor box will snap to the mid of the ray
or segment unless the segment is a conic in which case the snap
is to the vertex of the conic.
.pause 500
.mid_snap
.move -112 33
.pause 500
.annotation Specifies this point
.click -112 33
.fcr 20 -20
.unselect_all
.pause
.clear_annotations
.new_text
If more than one type of object lies within the cursor box then the snap
applies, in order of priority, to rays followed by tape measures followed
by segments of elements.
.annotation Clicking here with an mid snap
.fc -97 83
.fcr -10 10
.mid_snap
.move -97 83
.pause 500
.annotation Snaps on the ray not the prism
.click -97 83
.fcr 20 -20
.unselect_all
.pause
.clear_annotations
.new_text
If more that one of the same type of object lies within the cursor box then
the mid snap applies to the first of the objects that was constructed.
.pause
.goto MID1
:MIDLOOP
.painting 0
.unselect_all
.select_object ANNOT
.delete
.painting 1
:MID1
.new_text
Click on continue then move the cursor into the main Raytrace window
and place the small box in the cursor on one of the objects in the
ray diagram and click the primary mouse button to see the effect
of the mid snap.
.pause
.mid_snap
.user_click
.if== -1 FAIL
.no_snap
.unselect_all
.annotation Snaps to this point
.fc lastclick.x lastclick.y
.fcr 10 10
.=> ANNOT
.new_text
Do you want to try the mid snap on some of the other objects?
.yes_no MIDLOOP ENDEND
:ENDEND
.unselect_all
.select_object ANNOT
.delete
.return
:FAIL
.unselect_all
.new_text
The snap failed. You must not have positioned the box over an
appropriate object. Note that you must click on the outline of a region
object not on the coloured fill.


Click on continue and try again.
.pause
.goto MIDLOOP
