% Demonstrate tangent snaps. To be run from snaps.rsc - not stand alone
.new_text
A tangent snap can only be used on a circular arc segment of an element.
When you select a tangent snap the cursor changes to a small box and the
abreviation Tang't.
.pause
.new_text
The cursor should be positioned so that the box lies over some part
of a circular arc in an element.


There is only one such arc in this diagram. Click on continue and the
tangent snap will be demonstrated to you.
.pause
.annotation Clicking here
.fc 107 93
.fcr -20 -30
.new_text
Clicking with a tangent snap with an arc segment passing
through the small cursor box will snap to the tangent control
point of the arc.
.pause 500
.tangent_snap
.move 107 93
.pause 500
.annotation To find the tangent point
.click 107 93
.fcr 20 -20
.unselect_all
.pause
.new_text
When an arc segment is selected the tangent
control point is indicated by a drag handle.


It is the point
you must specify when using the End/Tangent method of
defining arc segments and the point you use to change the radius
of an arc by dragging.
.select_object ARC
.pause
.clear_annotations
.goto TAN1
:TANLOOP
.painting 0
.unselect_all
.select_object ANNOT
.delete
.painting 1
:TAN1
.unselect_all
.new_text
Click on continue then move the cursor into the main Raytrace window
and place the small box in the cursor anywhere over the arc segment
and click the primary mouse button to try this yourself.
.pause
.tangent_snap
.user_click
.if== -1 FAIL
.no_snap
.unselect_all
.annotation Snaps to this point
.fc lastclick.x lastclick.y
.fcr 10 10
.=> ANNOT
.new_text
Do you want to try the tangent snap on some of the other objects?
.yes_no TANLOOP ENDEND
:ENDEND
.unselect_all
.select_object ANNOT
.delete
.return
:FAIL
.unselect_all
.new_text
The snap failed. You must not have positioned the box over an
arc segment.


Click on continue and try again.
.pause
.goto TANLOOP
